#!/bin/bash

if [[ $EUID -ne 0 ]]; then
   echo "ERROR: Run this program under root, or sudo -s"
   exit 1
fi

if [[ ! -b /dev/mmcblk0 ]]; then 
    echo "ERROR: /dev/mmcblk0 not exist .. insert microSD card .."
    exit 1
fi


K3_FULLPATH=`realpath $0`
K3WRK_DIR=`dirname ${K3_FULLPATH}`

echo "Working directory = ${K3WRK_DIR}"

#BOOTTAR=`find ${K3WRK_DIR} -type f -name "*part1*gz" | head -n 1`
BOOTTAR=`find ${K3WRK_DIR} -maxdepth 1 -type f -name "boot-*gz" | head -n 1`
#ROOTTAR=`find ${K3WRK_DIR} -type f -name "*part2*gz" | head -n 1`
#ROOTTAR=`find ${K3WRK_DIR} -type f -name "*rootfs-4.7_arm-astra-mobile-arm64-no-szi*gz" | head -n 1`
#ROOTTAR=`find ${K3WRK_DIR} -type f -name "rootfs-4.7_arm-astra-mobile-arm64.tar.gz" | head -n 1`
ROOTTAR=`find ${K3WRK_DIR} -maxdepth 1 -type f -name "rootfs-4.7_arm-*.gz" | head -n 1`

echo "Boot archive = ${BOOTTAR}"
echo "Rootfs archive = ${ROOTTAR}"


dd if=/dev/zero of=/dev/mmcblk0 bs=1M count=100
sync

#dd if=${K3WRK_DIR}/imx-image-multimedia-imx8mnevk.wic of=/dev/mmcblk0p1 conv=fsync

echo "----------: disk partitions creation..."
parted -s -a optimal /dev/mmcblk0 \
mklabel msdos \
mkpart primary fat16 32MiB  1024MiB \
mkpart primary ext4  1024MiB 100% \
set 1 esp on \
print

sync
sleep 3

echo "----------: make fs on disk..."
mkfs.fat /dev/mmcblk0p1
mkfs.ext4 /dev/mmcblk0p2

sync
#dd if=${K3WRK_DIR}/imx-boot-imx8mnddr4evk-sd.bin-flash_ddr4_evk of=/dev/mmcblk0  bs=1k seek=32 conv=fsync
#dd if=${K3WRK_DIR}/imx-boot-imx8mpddr4evk-sd.bin-flash_ddr4_evk of=/dev/mmcblk0  bs=1k seek=32 conv=fsync

#dd if=${K3WRK_DIR}/imx-boot-imx8mpevk-sd.bin-flash_evk of=/dev/sdd  bs=1k seek=32 conv=fsync
#dd if=${K3WRK_DIR}/flash.bin of=/dev/sdd  bs=1k seek=32 conv=fsync
#dd if=${K3WRK_DIR}/imx-boot-imx8mpevk-sd_11_05_23.bin-flash_evk of=/dev/mmcblk0  bs=1k seek=32 conv=fsync
#dd if=${K3WRK_DIR}/flash_05_06_23.bin of=/dev/mmcblk0  bs=1k seek=32 conv=fsync
dd if=${K3WRK_DIR}/flash.bin of=/dev/mmcblk0 bs=1k seek=32 conv=fsync


mkdir -p /mnt/{part1,part2}
mount /dev/mmcblk0p1 /mnt/part1
mount /dev/mmcblk0p2 /mnt/part2

echo "----------: unpack boot to disk..."
tar  -h -zxf ${BOOTTAR}  -C /mnt/part1
#--xattrs --xattrs-include='*' --strip-components 1 --no-same-owner

echo "----------: unpack rootfs to disk..."
tar --xattrs --xattrs-include='*' -zxpf ${ROOTTAR} -C /mnt/part2
# --strip-components 1

echo "----------- BOOT:"
ls -la /mnt/part1

echo "----------- ROOTFS:"
ls -la /mnt/part2

sync
umount /mnt/part1
umount /mnt/part2

echo "done"
