#!/bin/bash

K3_FULLPATH=`realpath $0`
K3WRK_DIR=`dirname ${K3_FULLPATH}`

set -e -u

ROOTX86DIR=`find ${K3WRK_DIR} -type d -name "rootfs*x86*" | head -n 1`

[[ ! -d "${ROOTX86DIR}" ]] && exit 1

tar --acls --xattrs -cpf ${ROOTX86DIR}.tar -C ${ROOTX86DIR} .
gzip --fast ${ROOTX86DIR}.tar

md5sum ${ROOTX86DIR}.tar.gz > ${ROOTX86DIR}.tar.gz.md5

echo "DONE: "
ls -lah ${ROOTX86DIR}.tar*
