#!/bin/bash

K3_FULLPATH=`realpath $0`
K3WRK_DIR=`dirname ${K3_FULLPATH}`


ARCH="arm64"
CODENAME="4.7_arm"
EDITION="astra-mobile"
TYPE=""

CHROOT_DIR=rootfs-$CODENAME-$EDITION-$ARCH$TYPE

set -e -u

ROOTARM64DIR=`find ${K3WRK_DIR} -type d -name "rootfs*arm64*" | head -n 1`

[[ ! -d "${ROOTARM64DIR}" ]] && exit 1


tar --acls --xattrs -cpf rootfs-$CODENAME-$EDITION-$ARCH$TYPE.tar -C ${CHROOT_DIR} .
gzip --fast rootfs-$CODENAME-$EDITION-$ARCH$TYPE.tar
md5sum rootfs-$CODENAME-$EDITION-$ARCH$TYPE.tar.gz > rootfs-$CODENAME-$EDITION-$ARCH$TYPE.tar.gz.md5
gostsum -d rootfs-$CODENAME-$EDITION-$ARCH$TYPE.tar.gz > rootfs-$CODENAME-$EDITION-$ARCH$TYPE.tar.gz.gost

tar --exclude='vmlinuz' --exclude='vmlinuz.old' --exclude='initrd.img*' --exclude="grub" -cpf boot-part1-$CODENAME-$EDITION-$ARCH$TYPE.tar -h -C ${CHROOT_DIR}/boot .
gzip --fast boot-part1-$CODENAME-$EDITION-$ARCH$TYPE.tar
md5sum boot-part1-$CODENAME-$EDITION-$ARCH$TYPE.tar.gz > boot-part1-$CODENAME-$EDITION-$ARCH$TYPE.tar.gz.md5
gostsum -d boot-part1-$CODENAME-$EDITION-$ARCH$TYPE.tar.gz > boot-part1-$CODENAME-$EDITION-$ARCH$TYPE.tar.gz.gost
cp -f "$CHROOT_DIR"/usr/share/u-boot-imx8/flash.bin ${K3WRK_DIR}/flash.bin
